PROGRAM LodeRunnerLive;

USES DOSFileAccess,LRLRoutines,LRLSprites,LRLLevels,LRLMainMenu,
     LRLHighScores,LRLEditor,LRLIntroduction;

CONST
   Version: ARRAY [1..34] OF CHAR =
   'Lode Runner LIVE. Version 1.0'#13#10#13#10'$';

PROCEDURE LRLInitialize;
BEGIN
	ASM
		LEA DX,Version
		MOV AH,9
		INT 21H
	END;
	CheckHardware;
	ImagesInitialize;
	VideoModeSet($13);
END;

PROCEDURE LRLDeinitialize;
BEGIN
	VideoModeSet($3);
	ImagesDeinitialize;
END;

PROCEDURE LRLGameStart;
VAR
	cl: INTEGER;
BEGIN
	Palette256Set(LRLPalette^);
	ShowLives:=TRUE;
	ShowScore:=TRUE;
	ShowLevel:=TRUE;
	LRLLives:=5;
	LRLScore:=0;
	cl:=1;
	REPEAT
		LRLPlayLevel(cl);
		KeyboardFlush;
		IF GameResult=10 THEN BEGIN
			INC(LRLLives);
			LRLScore:=LRLScore+10000*LONGINT(cl);
			INC(cl);
		END
		ELSE
		BEGIN
			DEC(LRLLives)
		END;
	UNTIL (LRLLives=0) OR (GameResult=100);
	IF GameResult<>100 THEN BEGIN
		IF LRLBestScore(LRLScore) THEN BEGIN
			LRLInsertScore(LRLEnterName,LRLScore);
			LRLShowHighScores;
		END;
	END;
END;

PROCEDURE LRLShell;
VAR
	MenuSelection: WORD;
BEGIN
	MenuSelection:=1;
	REPEAT
		LRLSelectItem(MenuSelection);
		IF MenuSelection=1 THEN BEGIN
			LRLGameStart;
		END;
		IF MenuSelection=2 THEN BEGIN
			LRLEditLevels;
		END;
		IF MenuSelection=3 THEN BEGIN
			LRLShowHighScores;
		END;
	UNTIL MenuSelection=4;
END;

BEGIN
	DisableInterrupts;
	LRLInitialize;
	LRLIntro;
	LRLShell;
	LRLDeinitialize;
	EnableInterrupts;
END.

