UNIT LRLEditor;

INTERFACE

USES DOSFileAccess,LRLRoutines,LRLSprites,LRLLevels;

PROCEDURE LRLEditLevels;

IMPLEMENTATION

VAR
	CurrentLevel: WORD;
	CurrentTool: WORD;
	TotalLevels: WORD;
	MouseX,MouseY: INTEGER;
	TimeToRefresh: BOOLEAN;
	RefreshDelay: WORD;
	RefreshRemain: WORD;
	OldTimer: POINTER;

PROCEDURE LRLRedrawLevel;
VAR
	i,j: INTEGER;
BEGIN
	ImageClear(LRLScreen^);
	FOR i:=1 TO 16 DO
		FOR j:=1 TO 30 DO
			WITH LRLLevel.Field[j,i] DO
				ImagePut(LRLScreen^,LRLEnvironment[Image].Image[Count].Data^,
       j*10,i*10,0,0,319,199);
	FOR i:=1 TO 10 DO
		WITH LRLLevel.Player[i] DO BEGIN
			IF Controller<>0 THEN
				ImagePutTransparent(LRLScreen^,LRLFigure[Colour,
       SpriteData].Image[Sprite].Data^,
				Position.x*10+Position.xoffs,Position.y*10+Position.yoffs,0,0,319,199);
		END;
	ImageFill(LRLFontBuffer^,12,12,252);
	ImagePut(LRLScreen^,LRLFontBuffer^,10,184,0,0,319,199);
	FOR i:=1 TO 13 DO BEGIN
		IF i>9 THEN
			ImagePut(LRLScreen^,LRLFigure[i-9,1].Image[1].Data^,i*15-4,185,0,0,319,199)
		ELSE
			ImagePut(LRLScreen^,LRLEnvironment[i].Image[1].Data^,i*15-4,185,0,0,319,199);
	END;
	FOR i:=1 TO 6 DO BEGIN
		IF LRLEditorButton[i].Lit THEN
			ImagePut(LRLScreen^,LRLEditorButton[i].LightIcon^,LRLEditorButton[i].x1,LRLEditorButton[i].y1,0,0,319,199)
		ELSE
			ImagePut(LRLScreen^,LRLEditorButton[i].DarkIcon^,LRLEditorButton[i].x1,LRLEditorButton[i].y1,0,0,319,199)
	END;
	LRLDrawOrnamental(0,0,31,17,1);
END;

PROCEDURE RefreshRunner;
INTERRUPT;
ASSEMBLER;
ASM
	DEC RefreshRemain
	JNZ @DoTimer

	MOV AX,RefreshDelay
	MOV RefreshRemain,AX
	MOV TimeToRefresh,-1

@DoTimer:
	PUSHF
	CALL OldTimer
END;

PROCEDURE LRLMoveMouse;
VAR
	s,s2: STRING[20];
BEGIN
	MSMouseGetXY(Mousex,Mousey);
	IF NOT MSMouseInArea(200,180,325,205) THEN BEGIN
		IF CurrentTool<10 THEN
			ImagePut(LRLScreen^,LRLEnvironment[CurrentTool].Image[1].Data^,Mousex-5,Mousey-5,0,0,319,199)
		ELSE
			ImagePut(LRLScreen^,LRLFigure[CurrentTool-9,1].Image[1].Data^,Mousex-5,Mousey-5,0,0,319,199)
	END;
	IF NOT MSMouseInArea(-2,-2,55,20) THEN BEGIN
		ImageFill(LRLFontBuffer^,50,15,0);
		ImagePut(LRLScreen^,LRLFontBuffer^,0,0,0,0,319,199);
		STR(CurrentLevel,s);
		STR(TotalLevels,s2);
		ImageStringGet(s+'/'+s2,LRLFont^,LRLFontBuffer^,251);
		ImagePut(LRLScreen^,LRLFontBuffer^,25-ImageSizex(LRLFontBuffer^) DIV 2,0,0,0,319,199);
    END;
	ImagePutTransparent(LRLScreen^,LRLMousePointer^,Mousex,Mousey,0,0,319,199);
END;

PROCEDURE RePress;
VAR
	x,y: INTEGER;
BEGIN
	MSMouseButtonWasPressed(1,x,y);
	MSMouseButtonWasReleased(1,x,y);
	MSMouseButtonWasPressed(4,x,y);
	MSMouseButtonWasReleased(4,x,y);
END;

PROCEDURE LRLEditLevels;
VAR
	Keypress: WORD;
	NeedToFade: BOOLEAN;
	DrawNow: BOOLEAN;
	i,j: INTEGER;
	x,y: INTEGER;
	Cmd: WORD;
BEGIN
	IF NOT MSMouseDriverExist THEN EXIT;
	Repress;
	ShowLives:=FALSE;
	ShowScore:=FALSE;
	Palette256Set(LRLPalette^);
	OldTimer:=SetInterrupt($8,@RefreshRunner);
	Keypress:=0;
	RefreshDelay:=1;
	RefreshRemain:=1;
	CurrentLevel:=1;
	CurrentTool:=2;
	TotalLevels:=LRLLevelCount;
	TimeToRefresh:=TRUE;
	DrawNow:=FALSE;
	MSMouseSetXY(160,100);
	LRLLoadLevel(CurrentLevel);
	REPEAT
		IF TimeToRefresh THEN BEGIN
			LRLRedrawLevel;
			LRLMoveMouse;
			ScreenApply(LRLScreen^);
			TimeToRefresh:=FALSE;
		END;
		IF Keypressed THEN BEGIN
			Keypress:=Readkey;
		END;
		IF MSMouseButtonWasReleased(1,x,y) THEN BEGIN
			LRLScore:=0;
			FadeClear;
			ImageClear(LRLScreen^);
			ScreenApply(LRLScreen^);
			Palette256Set(LRLPalette^);
			LRLPlayLevel(CurrentLevel);
			FadeClear;
			ImageClear(LRLScreen^);
			ScreenApply(LRLScreen^);
			Palette256Set(LRLPalette^);
			LRLLoadLevel(CurrentLevel);
			Repress;
		END;
		IF MSMouseButtonWasPressed(0,x,y) THEN BEGIN
			DrawNow:=TRUE;
		END;
		IF MSMouseButtonWasReleased(0,x,y) THEN BEGIN
			DrawNow:=FALSE;
			Cmd:=0;
			FOR i:=1 TO 6 DO
				LRLEditorButton[i].Lit:=FALSE;
			FOR i:=1 TO 6 DO BEGIN
				IF MSMouseInArea(LRLEditorButton[i].x1,LRLEditorButton[i].y1,
					LRLEditorButton[i].x2,LRLEditorButton[i].y2) THEN BEGIN
					Cmd:=LRLEditorButton[i].Command;
					BREAK;
				END;
			END;
			IF (Cmd=1) THEN
				LRLSaveLevel(CurrentLevel);
				Repress;
			IF (Cmd=2) THEN BEGIN
				LRLInsertLevel(CurrentLevel);
				INC(CurrentLevel);
				TotalLevels:=LRLLevelCount;
				LRLLoadLevel(CurrentLevel);
				Repress;
			END;
			IF (Cmd=3) AND (CurrentLevel<TotalLevels) THEN BEGIN
				INC(CurrentLevel);
				LRLLoadLevel(CurrentLevel);
				Repress;
			END;
			IF (Cmd=4) THEN BEGIN
				FOR i:=1 TO 16 DO
					FOR j:=1 TO 30 DO
						LRLLevel.Field[j,i].Image:=1;
				FOR i:=1 TO 10 DO
					LRLLevel.Player[i].Controller:=0;
				Repress;
			END;
			IF (Cmd=5) AND (TotalLevels>1) THEN BEGIN
				LRLDeleteLevel(CurrentLevel);
				TotalLevels:=LRLLevelCount;
				IF CurrentLevel>TotalLevels THEN CurrentLevel:=TotalLevels;
				LRLLoadLevel(CurrentLevel);
				Repress;
			END;
			IF (Cmd=6) AND (CurrentLevel>1) THEN BEGIN
				DEC(CurrentLevel);
				LRLLoadLevel(CurrentLevel);
				Repress;
			END;
			MSMouseGetXY(Mousex,Mousey);
			IF (Mousey>180) THEN BEGIN
				FOR i:=1 TO 13 DO BEGIN
					IF (Mousey>184) AND (Mousey<195) AND
						(Mousex>i*15-5) AND (Mousex<i*15+6) THEN BEGIN
						CurrentTool:=i;
						BREAK;
					END;
				END;
			END;
		END;
		IF DrawNow THEN BEGIN
			FOR i:=1 TO 6 DO
				LRLEditorButton[i].Lit:=FALSE;
			FOR i:=1 TO 6 DO BEGIN
				IF MSMouseInArea(LRLEditorButton[i].x1,LRLEditorButton[i].y1,
					LRLEditorButton[i].x2,LRLEditorButton[i].y2) THEN BEGIN
					LRLEditorButton[i].Lit:=TRUE;
					BREAK;
				END;
			END;
			MSMouseGetXY(Mousex,Mousey);
			x:=(Mousex) DIV 10;
			y:=(Mousey) DIV 10;
			IF (x>0) AND (x<31) AND (y>0) AND (y<17) THEN BEGIN
				FOR i:=1 TO 10 DO BEGIN
					IF (LRLLevel.Player[i].Controller<>0) AND
					(LRLLevel.Player[i].Position.x=x) AND
					(LRLLevel.Player[i].Position.y=y) THEN BEGIN
						IF (CurrentTool<>2) AND (CurrentTool<>3) AND
						(CurrentTool<>4) AND (CurrentTool<>7) THEN BEGIN
							LRLLevel.Player[i].Controller:=0;
							BREAK;
						END;
					END;
				END;
				IF CurrentTool<10 THEN
					LRLLevel.Field[x,y].Image:=CurrentTool
				ELSE
				BEGIN
					IF (LRLLevel.Field[x,y].Image=2) OR
					(LRLLevel.Field[x,y].Image=3) OR
					(LRLLevel.Field[x,y].Image=4) OR
					(LRLLevel.Field[x,y].Image=1) THEN BEGIN
						IF CurrentTool=10 THEN BEGIN
							LRLLevel.Player[1].Controller:=1;
							LRLLevel.Player[1].Position.x:=x;
							LRLLevel.Player[1].Position.y:=y;
							LRLLevel.Player[1].Colour:=1;
						END
						ELSE
						BEGIN
							j:=2;
							FOR i:=2 TO 10 DO BEGIN
								IF LRLLevel.Player[i].Controller=0 THEN BEGIN
									j:=i;
									BREAK;
								END;
							END;
							LRLLevel.Player[j].Controller:=2;
							LRLLevel.Player[j].Position.x:=x;
							LRLLevel.Player[j].Position.y:=y;
							LRLLevel.Player[j].Colour:=CurrentTool-9;
						END;
					END;
				END;
			END;
		END;
	UNTIL (LO(Keypress)=27);
	SetInterrupt($8,OldTimer);
END;

END.

