UNIT LRLMainMenu;
INTERFACE
USES DOSFileAccess,LRLRoutines,LRLSprites;

PROCEDURE LRLSelectItem(VAR Item: WORD);

IMPLEMENTATION
VAR
	MainScreen: POINTER;
	Selection: ARRAY[1..4] OF POINTER;
	SelectionDark: ARRAY[1..4] OF POINTER;
	SelectionSize: ARRAY[1..4] OF WORD;
	SelectionDarkSize: ARRAY[1..4] OF WORD;

PROCEDURE LoadData;
VAR
	size,j: WORD;
	i: INTEGER;
BEGIN
	GETMEM(MainScreen,64004);
	DFAFilePositionSet(ImageFile,LRLImagesFilePosition+7940,DFASeekFromStart);
	DFAFileRead(ImageFile,MainScreen^,64004,j);
	FOR i:=1 TO 4 DO BEGIN
		DFAFileRead(ImageFile,SelectionSize[i],2,j);
		GETMEM(Selection[i],SelectionSize[i]);
		DFAFileRead(ImageFile,Selection[i]^,SelectionSize[i],j);
		DFAFileRead(ImageFile,SelectionDarkSize[i],2,j);
		GETMEM(SelectionDark[i],SelectionDarkSize[i]);
		DFAFileRead(ImageFile,SelectionDark[i]^,SelectionDarkSize[i],j);
	END;
END;

PROCEDURE DisposeData;
VAR
	i: INTEGER;
BEGIN
	FREEMEM(MainScreen,64004);
	FOR i:=1 TO 4 DO BEGIN
		FREEMEM(Selection[i],SelectionSize[i]);
		FREEMEM(SelectionDark[i],SelectionDarkSize[i]);
	END;
END;

PROCEDURE LRLSelectItem(VAR Item: WORD);
VAR
	Keypress: WORD;
	RedrawAll: BOOLEAN;
	NeedToFade: BOOLEAN;
	p: POINTER;
	i: INTEGER;
BEGIN
	GETMEM(p,768);
	DataFill(p^,768,0,0);
	Palette256Set(p^);
	FREEMEM(p,768);
	LoadData;
	NeedToFade:=TRUE;
	ImagePut(LRLScreen^,MainScreen^,0,0,0,0,319,199);
	RedrawAll:=TRUE;
	KeyboardFlush;
	REPEAT
		IF RedrawAll THEN BEGIN
			FOR i:=1 TO 4 DO BEGIN
				IF i=Item THEN
					ImagePutTransparent(LRLScreen^,Selection[i]^,63,66+(i-1)*30,0,0,319,199)
				ELSE
					ImagePutTransparent(LRLScreen^,SelectionDark[i]^,63,66+(i-1)*30,0,0,319,199);
			END;
			ScreenApply(LRLScreen^);
			IF NeedToFade THEN BEGIN
				FadeTo(LRLMenuPalette);
				NeedToFade:=FALSE;
			END;
			RedrawAll:=FALSE;
		END;
		Keypress:=Readkey;
		IF LO(Keypress)=0 THEN BEGIN
			IF (HI(Keypress)=80) AND (Item<4) THEN BEGIN
				INC(Item);
				RedrawAll:=TRUE;
			END;
			IF (HI(Keypress)=72) AND (Item>1) THEN BEGIN
				DEC(Item);
				RedrawAll:=TRUE;
			END;
		END;
	UNTIL LO(Keypress)=13;
	FadeClear;
	ImageClear(LRLScreen^);
	ScreenApply(LRLScreen^);
	DisposeData;
END;
END.

